// ****************************************************************************************************
// File: Boxes.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_BOXES
#define HURRICANE_BOXES

#include "Collection.h"
#include "Box.h"

namespace Hurricane {



// ****************************************************************************************************
// Boxes declaration
// ****************************************************************************************************

typedef GenericCollection<Box> Boxes;



// ****************************************************************************************************
// BoxLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Box> BoxLocator;



// ****************************************************************************************************
// BoxFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Box> BoxFilter;



// ****************************************************************************************************
// for_each_box declaration
// ****************************************************************************************************

#define for_each_box(box, boxes)\
/*******************************/\
{\
	BoxLocator _locator = boxes.GetLocator();\
	while (_locator.IsValid()) {\
		Box box = _locator.GetElement();\
		_locator.Progress();



} // End of Hurricane namespace.

#endif // HURRICANE_BOXES

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
