// ****************************************************************************************************
// File: Pads.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_PADS
#define HURRICANE_PADS

#include "Collection.h"

namespace Hurricane {

class Pad;



// ****************************************************************************************************
// Pads declaration
// ****************************************************************************************************

typedef GenericCollection<Pad*> Pads;



// ****************************************************************************************************
// PadLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Pad*> PadLocator;



// ****************************************************************************************************
// PadFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Pad*> PadFilter;



// ****************************************************************************************************
// for_each_pad declaration
// ****************************************************************************************************

#define for_each_pad(pad, pads)\
/******************************/\
{\
	PadLocator _locator = pads.GetLocator();\
	while (_locator.IsValid()) {\
		Pad* pad = _locator.GetElement();\
		_locator.Progress();



} // End of Hurricane namespace.

#endif // HURRICANE_PADS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
