// ****************************************************************************************************
// File: Quarks.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_QUARKS
#define HURRICANE_QUARKS

#include "Collection.h"

namespace Hurricane {

class Quark;



// ****************************************************************************************************
// Quarks declaration
// ****************************************************************************************************

typedef GenericCollection<Quark*> Quarks;



// ****************************************************************************************************
// QuarkLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Quark*> QuarkLocator;



// ****************************************************************************************************
// QuarkFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Quark*> QuarkFilter;



// ****************************************************************************************************
// for_each_quark declaration
// ****************************************************************************************************

#define for_each_quark(quark, quarks)\
/************************************/\
{\
	QuarkLocator _locator = quarks.GetLocator();\
	while (_locator.IsValid()) {\
		Quark* quark = _locator.GetElement();\
		_locator.Progress();



} // End of Hurricane namespace.

#endif // HURRICANE_QUARKS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
