// ****************************************************************************************************
// File: Tags.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_TAGS
#define HURRICANE_TAGS

#include "Collection.h"

namespace Hurricane {

class Tag;



// ****************************************************************************************************
// Tags declaration
// ****************************************************************************************************

typedef GenericCollection<Tag*> Tags;



// ****************************************************************************************************
// TagLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Tag*> TagLocator;



// ****************************************************************************************************
// TagFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Tag*> TagFilter;



// ****************************************************************************************************
// for_each_tag declaration
// ****************************************************************************************************

#define for_each_tag(tag, tags)\
/******************************/\
{\
	TagLocator _locator = tags.GetLocator();\
	while (_locator.IsValid()) {\
		Tag* tag = _locator.GetElement();\
		_locator.Progress();



} // End of Hurricane namespace.

#endif // HURRICANE_TAGS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
