// ****************************************************************************************************
// File: Views.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_VIEWS
#define HURRICANE_VIEWS

#include "Collection.h"

namespace Hurricane {

class View;



// ****************************************************************************************************
// Views declaration
// ****************************************************************************************************

typedef GenericCollection<View*> Views;



// ****************************************************************************************************
// ViewLocator declaration
// ****************************************************************************************************

typedef GenericLocator<View*> ViewLocator;



// ****************************************************************************************************
// ViewFilter declaration
// ****************************************************************************************************

typedef GenericFilter<View*> ViewFilter;



// ****************************************************************************************************
// for_each_view declaration
// ****************************************************************************************************

#define for_each_view(view, views)\
/*********************************/\
{\
	ViewLocator _locator = views.GetLocator();\
	while (_locator.IsValid()) {\
		View* view = _locator.GetElement();\
		_locator.Progress();



} // End of Hurricane namespace.

#endif // HURRICANE_VIEWS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
